unit UFazendoChamadaE1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, voicerlibLib_TLB, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Image1: TImage;
    memStatus: TMemo;
    vlib: Tvoicerlib;
    btnLimpaLog: TButton;
    procedure btnLimpaLogClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
    procedure vlibAfterMakeCall(ASender: TObject; Port, Status: Smallint);
    procedure vlibCallStateChange(ASender: TObject; Port,
      Status: Smallint);
    procedure vlibBusyDetected(ASender: TObject; Port: Smallint);
    procedure vlibCalling(ASender: TObject; Port: Smallint);
    procedure vlibFaxDetected(ASender: TObject; Port: Smallint);
    procedure vlibPlayStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure vlibRingDetected(ASender: TObject; Port: Smallint);
    procedure vlibAfterPickup(ASender: TObject; Port: Smallint);
    procedure vlibE1StateChange(ASender: TObject; Port, State: Smallint);
    procedure vlibCallerID(ASender: TObject; Port: Smallint;
      const Number: WideString);
    procedure vlibR2Received(ASender: TObject; Port, Signal: Smallint);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DesligaTudo(nPorta : Integer);
  end;

var
  Form1: TForm1;
  sReturn    : array [0..255] of Char;
  nContToques : array [1..81] of Integer;
  nStatus : array [1..81] of Integer;
  sNumeroRecebido : array[1..60] of String;
  sBinaRecebido : array[1..60] of String;
  nFlagSaida : array[1..60] of Integer;

implementation

{$R *.dfm}

{Esta procedure coloca na tela os estados do programa
com hora e a porta}
procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' +sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.memStatus.Lines.Add(sMsg);
end;

procedure TForm1.DesligaTudo(nPorta : Integer);
var
  nRet: Integer;
begin

  //Se pegou ocupado e esta reproduzindo uma mensagem
  if vlib.IsPlaying(nPorta) then
  begin
    //Interrompe a reproducao da mensagem
    nRet := vlib.StopPlayFile(nPorta);
    //Trata o retorno
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(nPorta,'StopPlayFile - ' + sReturn);
  end;

  //Desliga a porta
  nRet := vlib.HangUp(nPorta);
  //Trata o retorno
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(nPorta,'Hangup - ' + sReturn);

  nContToques[nPorta] := 0;
  MostraStatus(nPorta, 'Zerou contador de toques:' + IntToStr(nContToques[nPorta])); 
end;


procedure TForm1.btnLimpaLogClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet, nPorta, nPlaca : Integer;
  cVersao : array[0..255] of Char;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

  //Inicializa a voicerlib
  nRet := vlib.StartVoicerLib;

  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));

  MostraStatus(0,'StartVoicerLib - Iniciou VoicerLib - ' + sReturn);

  if nRet = DG_EXIT_SUCCESS then //Se iniciou a voicerlib com sucesso
  begin
    //Informa quantidade de placas e portas
    MostraStatus(0,'Nmero Total de Placas: ' + IntToStr(vlib.GetCardsCount));
    MostraStatus(0,'Nmero Total de Portas: ' + IntToStr(vlib.GetPortsCount));   

    for nPlaca := 1 to vlib.GetCardsCount do
    begin     
      vlib.SetCardSyncMode(nPlaca, SYNC_LINE_A);
      //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
      vlib.SetAlarmMode(nPlaca, ALARM_AUTOMATIC_NOTIFY);
    end;  

    for nPorta := 1 to vlib.GetPortsCount do
    begin
      nFlagSaida[nPorta] := 0;
      //Cria thread do protocolo R2D
      nRet := vlib.CreateE1Thread(nPorta);
      if nRet <> DG_EXIT_SUCCESS then
      begin
        //Trata o retorno 
        vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
        MostraStatus(nPorta,'CreateE1Thread - ' + sReturn);
      end;

      //Configura thread E1

      //Categoria do Assinante
      vlib.ConfigE1Thread(nPorta, E1CFG_GROUP_II,1);
      //Seta o Bina
      vlib.SetPortID(nPorta, '1121916363');
      //Numero total de digitos a receber
      vlib.ConfigE1Thread(nPorta, E1CFG_MAXDIGITS_RX,4);
      //Status Grupo B
      vlib.ConfigE1Thread(nPorta, E1CFG_GROUP_B,1);
      //Em ligacoes de entrada, pede bina apos o 2 digito
      vlib.ConfigE1Thread(nPorta, E1CFG_SEND_ID_AFTERDIGIT,2);

      //Seta o formato de reproducao
      nRet := vlib.SetPlayFormat(nPorta,ffWaveULaw);
      if nRet <> DG_EXIT_SUCCESS then
      begin
        //Trata o retorno 
        vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
        MostraStatus(nPorta,'SetPlayFormat - ' + sReturn);
      end;

      //Configura a quantidade de rings a serem considerados como nao atendimento
      nRet:= vlib.SetCallNoAnswerRingCount(nPorta, 5);
      if nRet <> DG_EXIT_SUCCESS then
      begin
        //Trata o retorno
        vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
        MostraStatus(nPorta,'SetCallNoAnswerRingCount - ' + sReturn);
      end;

      //Configura as opoes apos a deteccao de atendimento do metodo MakeCall
      nRet:= vlib.SetCallAfterAnswer(nPorta,'' , 100, false);
      if nRet <> DG_EXIT_SUCCESS then
      begin
        //Trata o retorno
        vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
        MostraStatus(nPorta,'SetCallAfterAnswer - ' + sReturn);
      end;

    end;   
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  nRet,nPorta : integer;
begin

  for nPorta := 1 to vlib.GetPortsCount do
  begin 
    
    DesligaTudo(nPorta);

    //Destroi thread E1
    nRet := vlib.DestroyE1Thread(nPorta);
    //Trata o retorno
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(nPorta,'DestroyE1Thread - ' + sReturn);

    //Finaliza a voicerlib e testa seu retorno
    nRet := vlib.ShutdownVoicerLib;
    //Trata o retorno da finalizacao
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(0,'ShutDownVoicerLib - Finalizou VoicerLib - ' + sReturn);

  end;

end;

procedure TForm1.vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin

  //Verifica os alarmes 
  case AlarmCode of
    ALARM_RSLIP:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo) ON');
    end;

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_RESERVED:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;


procedure TForm1.vlibAfterMakeCall(ASender: TObject; Port,
  Status: Smallint);
var
  sDado: string;
begin

  //Retorno apos discagem
  case Status of
    mkOK:
      sDado := 'Ligao Finalizada.';

    mkNoDialTone:
      sDado := 'Sem tom de discagem.';

    mkDelivered:
      sDado := 'Ligao entregue sem superviso.';

    mkNoAnswer:
      sDado := 'Sem resposta. No atendeu';

    mkBusy:
      sDado := 'Ocupado.';

    mkAnswered:
    begin
      sDado := 'Ligao Atendida.';
      if Port >= 30 then
      begin
        //Faz a conexao bi-direcional entre duas portas
        vlib.LocalBridgeConnect(Port - 30 , Port);    
      end;

    end;

    mkAborted:
      sDado := 'MakeCall Abortado.';

    mkDialToneAfterDial:
      sDado := 'Recebeu tom de linha aps discagem.';

    mkFaxDetected:
      sDado := 'Fax detectado.';
  end;

  MostraStatus(Port,'OnAfterMakeCall -> ' + sDado);

  //DesligaTudo(Port);

end;

//Esse evento ocorre durante o MakeCall
procedure TForm1.vlibCallStateChange(ASender: TObject; Port,
  Status: Smallint);
var
  sStatus : String;
begin

  //Mostra o Status da Chamada
  case Status of

    csPlayingStartPhrase:
      sStatus:='Falando frase inicial';

    csPickingUp:
      sStatus:='Iniciando discagem externa';

    csDialingPrefix:
      sStatus:='Discando prefixo';

    csInitialFlash:
      sStatus:='Flash Inicial para Transferncia';

    csStartAnalysis:
      sStatus:='Iniciando superviso';

    csDialing:
      sStatus:='Discando';

    csCalling:
      sStatus:='Chamando...';

    csWaitingDialTone:
      sStatus:='Esperando tom de discagem...';

  end;

  MostraStatus(Port,'OnCallStateChange - ' + sStatus); 

end;

procedure TForm1.vlibBusyDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'OnBusyDetected');
  
  if Port > 30 then
  begin
    //Faz a desconexao bi-direcional entre duas portas
    vlib.LocalBridgeDisconnect(Port - 30, Port);
    vlib.HangUp(Port - 30);
     vlib.AbortCall(Port); 
  end
  else
  begin  
    //Faz a desconexao bi-direcional entre duas portas
    vlib.LocalBridgeDisconnect(Port, Port + 30);   
    vlib.HangUp(Port + 30);
    vlib.AbortCall(Port + 30); 
  end;
   
  DesligaTudo(Port);

end;

procedure TForm1.vlibCalling(ASender: TObject; Port: Smallint);
var 
  nRet : Integer;
begin

  inc(nContToques[Port]);
  MostraStatus(Port,'OnCalling ' + IntToStr(nContToques[Port]) + ' toque(s)...');

  //Se tocar 5 vezes considera nao atendimento
  if nContToques[Port] >= 5 then
  begin
    MostraStatus(Port, 'Destino no atendeu...');

    //Desliga a porta
    nRet := vlib.HangUp(Port);
    //Trata o retorno
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(Port,'Hangup - ' + sReturn);
  end;
end;

procedure TForm1.vlibFaxDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'OnFaxDetected');

  if Port > 30 then
  begin
    //Faz a desconexao bi-direcional entre duas portas
    vlib.LocalBridgeDisconnect(Port - 30, Port);
    vlib.HangUp(Port - 30); 
  end
  else
  begin  
    //Faz a desconexao bi-direcional entre duas portas
    vlib.LocalBridgeDisconnect(Port, Port+30);   
    vlib.HangUp(Port + 30); 
  end;

  vlib.AbortCall(Port);

  DesligaTudo(Port);
end;

procedure TForm1.vlibPlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet:Integer;
begin
  if Port <= 30 then
  begin
    //Verifica o retorno do fim da reproducao
    if StopStatus = ssNormal then
    begin
      MostraStatus(Port,'OnPlayStop - Finalizou a reproduo da mensagem com sucesso');
      //Repassa o BINA recebido
      vlib.SetPortID(Port + 30, sBinaRecebido[Port]);

      //Efetua chamada passando as opcoes do MakeCall
      nRet:= vlib.MakeCall(Port + 30, ctExternal, sNumeroRecebido[Port], '', true,dtTone);
      MostraStatus(Port,'MakeCall - Nmero Discado: ' + sNumeroRecebido[Port]);
 
      if nRet <> DG_EXIT_SUCCESS then
      begin
        //Trata o retorno
        vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
        MostraStatus(Port,'MakeCall - ' + sReturn);
      end; 
    end
    else
    begin
      //Verifica se parou a reproducao porque o metodo StopPlayFile foi chamado
      if StopStatus = ssStopped then
        MostraStatus(Port,'OnPlayStop - Reproduo da frase foi interrompida por fax ou ocupado')
      else
        MostraStatus(Port,'OnPlayStop - Erro ao finalizar reproduo da mensagem');    

      DesligaTudo(Port);   
    end;
  end;
end;

procedure TForm1.vlibRingDetected(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin
  MostraStatus(Port,'OnRingDetected');   

  //Atende a porta
  nRet := vlib.PickUp(Port,1000);
  //Trata o retorno
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(Port,'Pickup - ' + sReturn);  
 
end;

procedure TForm1.vlibAfterPickup(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin
  MostraStatus(Port,'OnAfterPickup');
  nContToques[Port] := 0; 
  if nFlagSaida[Port] = 0 then
  begin  
    //Reproduz um arquivo de audio
    nRet := vlib.PlayFile(Port,ExtractFilePath(Application.ExeName) + 'Mensagem.wav', '',0); 
    //Trata o retorno
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(Port,'PlayFile - ' + sReturn + ' arquivo: ' + ExtractFilePath(Application.ExeName) + 'Mensagem.wav');
  end;
end;

procedure TForm1.vlibE1StateChange(ASender: TObject; Port,
  State: Smallint);
begin
  
  if State = C_NUMBER_RECEIVED then
  begin
    sNumeroRecebido[Port] := vlib.GetE1Number(Port);
    MostraStatus(Port,'Nmero de B recebido: ' + sNumeroRecebido[Port]);  
  end;
end;

procedure TForm1.vlibCallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);
begin
  sBinaRecebido[Port]:= Number;
  MostraStatus(Port,'Nmero de A recebido: ' + sBinaRecebido[Port]); 
end;

procedure TForm1.vlibR2Received(ASender: TObject; Port, Signal: Smallint);
var
  nRet : Integer;
begin
  MostraStatus(Port,'R2--------------- - ' + IntToStr(signal));
  
  case signal of
      
    R2_SEIZURE:
    begin
      MostraStatus(Port,'Entrou R2_SEIZURE');
      if Port > 30 then
      begin
        MostraStatus(Port,'DisableE1Thread');
        //Desabilita thread de E1
        nRet := vlib.DisableE1Thread(Port);
        if nRet <> DG_EXIT_SUCCESS then
        begin
          //Trata o retorno 
          vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
          MostraStatus(Port,'DisableE1Thread - ' + sReturn);
        end;

        MostraStatus(Port - 30,'DisableE1Thread');
        nRet := vlib.DisableE1Thread(Port - 30);
        if nRet <> DG_EXIT_SUCCESS then
        begin
          //Trata o retorno 
          vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
          MostraStatus(Port - 30,'DisableE1Thread - ' + sReturn);
        end;

        MostraStatus(Port,'LocalBridgeConnect');
        //Faz a conexao bi-direcional entre duas portas
        nRet := vlib.LocalBridgeConnect(Port - 30 , Port);    
        if nRet <> DG_EXIT_SUCCESS then
        begin
          //Trata o retorno 
          vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
          MostraStatus(Port,'LocalBridgeConnect - ' + sReturn);
        end;
        MostraStatus(Port,'nFlagSaida[Port] := 1');        
        //Ligacao de Saida
        nFlagSaida[Port] := 1;
        nFlagSaida[Port-30] := 1;        
      end;  
    end;
  
    R2_IDLE:
    begin
      MostraStatus(Port,'R2_IDLE'); 
      //Ligacao de saida 
      if nFlagSaida[Port] <> 0 then
      begin

        vlib.SendR2Command(Port, Signal);
        if Port <= 30 then
          vlib.SendR2Command(Port + 30, Signal)
        else
          vlib.SendR2Command (Port - 30, Signal);  

        MostraStatus(Port,'EnableE1Thread');
        //Habilita thread de E1
        nRet := vlib.EnableE1Thread(Port);
        if nRet <> DG_EXIT_SUCCESS then
        begin
          //Trata o retorno 
          vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
          MostraStatus(Port,'EnableE1Thread - ' + sReturn);
        end; 

        if Port > 30 then
        begin
          MostraStatus(Port,'LocalBC');
          //Faz a desconexao bi-direcional entre duas portas
          nRet := vlib.LocalBridgeDisconnect(Port - 30 , Port);
        end
        else   
        begin
          MostraStatus(Port,'LocalBD');
          //Faz a desconexao bi-direcional entre duas portas
          nRet := vlib.LocalBridgeDisconnect(Port + 30 , Port); 
        end;

        if nRet <> DG_EXIT_SUCCESS then
        begin
          //Trata o retorno 
          vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
          MostraStatus(Port,'LocalBridgeDisconnect - ' + sReturn);
        end;

        nFlagSaida[Port] := 0;

      end;                                 
    end;      
  end;
    
  if nFlagSaida[Port] <> 0 then
  begin
    if Port <= 30 then
      vlib.SendR2Command(Port + 30, Signal)
    else
      vlib.SendR2Command (Port - 30, Signal);  
  end;

end;

end.
